#include "2darray.h"

BOOL C2DArray::Grow(UINT iSize)
{
	LPBYTE	lpNew		= NULL;
	UINT 	iNewSize	= m_iMax << 1;

	if( iNewSize < iSize )
		iNewSize += iSize;

	if( (lpNew = m_realloc(NULL, iNewSize * iNewSize)) != NULL )
	{
		for(UINT i = m_iSize; i-- ; )
			memmove(lpNew + iNewSize * i, m_lpArray + m_iMax * i, m_iSize);

		free(m_lpArray);
		m_lpArray	= lpNew;
		m_iMax		= iNewSize;
		m_iSize 	= iSize;
	}
	return (lpNew != NULL);
}

UINT C2DArray::SumRow(INT iRow)
{
	UINT		iRes = 0;

	for(UINT i = GetCount(); i-- ; )
		if( GetAt(iRow, i) )
			++iRes;

	return iRes;
}

UINT C2DArray::SumCol(INT iCol)
{
	UINT		iRes = 0;

	for(UINT i = GetCount(); i-- ; )
		if( GetAt(i, iCol) )
			++iRes;

	return iRes;
}
