#pragma once
//#include <windows.h>
#include "stdafx.h"

#define	DEFAULT_IMAX		5

class C2DArray
{
public:
	C2DArray(UINT iMax = DEFAULT_IMAX);
	~C2DArray(VOID);

	UINT	GetCount(VOID);
	UINT	GetSize(VOID);
	BOOL	Grow(UINT iSize);
	VOID	RemoveAll();

	BYTE	GetAt(UINT iRow, UINT iCol);
	BOOL	SetAt(UINT iRow, UINT iCol, BYTE b);

	UINT	SumRow(INT iRow);
	UINT	SumCol(INT iCol);

protected:
	LPBYTE	m_lpArray;
	UINT	m_iSize;
	UINT	m_iMax;

private:
	LPBYTE	m_realloc(LPBYTE buffer, DWORD size);
};

inline C2DArray::C2DArray(UINT iMax /* = DEFAULT_IMAX */)
{
	m_iSize		= 0;
	m_iMax		= iMax;
	m_lpArray	= m_realloc(NULL, m_iMax * m_iMax);
}

inline C2DArray::~C2DArray(VOID)
{
	if( m_lpArray )
		free(m_lpArray);
}

inline UINT C2DArray::GetCount(VOID)
{
	return m_iSize;
}

inline UINT C2DArray::GetSize(VOID)
{
	return GetCount();
}

inline BYTE C2DArray::GetAt(UINT iRow, UINT iCol)
{
	if( (iRow >= m_iSize) || (iCol >= m_iSize) )
		return 0;
	return m_lpArray[iRow * m_iMax + iCol];
}

inline BOOL C2DArray::SetAt(UINT iRow, UINT iCol, BYTE b)
{
	if( iRow >= m_iMax )
		if( !Grow(iRow) )
			return FALSE;
	if( iCol >= m_iMax )
		if( !Grow(iCol) )
			return FALSE;
	
	m_lpArray[iRow * m_iMax + iCol]	= b;

	if( iRow >= m_iSize )
		m_iSize = iRow + 1;
	if( iCol >= m_iSize )
		m_iSize = iCol + 1;
	return TRUE;
}

inline VOID C2DArray::RemoveAll()
{
	m_iMax		= DEFAULT_IMAX;
	m_lpArray	= m_realloc(m_lpArray, m_iMax * m_iMax);
}

inline LPBYTE C2DArray::m_realloc(LPBYTE buffer, DWORD size)
{
	LPBYTE	_buffer;

	if( (_buffer = (LPBYTE)realloc(buffer, size)) != NULL )
		memset(_buffer, 0, size);

	return _buffer;
}
